package pl.edu.agh.ssm2006.jpeg2000demo;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;

import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JInternalFrame;

public class ImageInternalFrame extends JInternalFrame {
	private static int positionInset = 1;

	private JCheckBoxMenuItem menuItem;

	private static final int SIZEX = 1000;

	private static final int SIZEY = 375;

	public ImageInternalFrame(String label, JCheckBoxMenuItem menuItm) {
		super(label, true, true, true, false);
		setLocation(positionInset * 20, positionInset * 20);
		positionInset = positionInset % 10 + 1;
		this.menuItem = menuItm;
		addVetoableChangeListener(new VetoableChangeListener() {
			public void vetoableChange(PropertyChangeEvent e)
					throws PropertyVetoException {
				if (e.getPropertyName().equals(IS_CLOSED_PROPERTY)
						&& (((Boolean) e.getOldValue()).booleanValue() == false)) {
					menuItem.setSelected(false);
					setVisible(false);
					throw new PropertyVetoException(IS_CLOSED_PROPERTY, e);
				}
			}

		});
		initComponents();
		jLabel1.setIcon(new ImageIcon(new BufferedImage(SIZEX, SIZEY,
				BufferedImage.TYPE_BYTE_GRAY)));
		pack();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed" desc=" Generated Code ">
	private void initComponents() {
		jScrollPane1 = new javax.swing.JScrollPane();
		jLabel1 = new javax.swing.JLabel();

		setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
		jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jScrollPane1.setViewportView(jLabel1);

		getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

		pack();
	}// </editor-fold>

	// Variables declaration - do not modify
	private javax.swing.JLabel jLabel1;

	private javax.swing.JScrollPane jScrollPane1;

	// End of variables declaration

	public void setImage(Image image) {
		jLabel1.setIcon(new ImageIcon(image));
	}

}
